Description

=begin

[Feature #5785]でinsert_textなどが追加されましたが、line_bufferを編集するためにはdelete_textも必要ではないでしょうか。

現状ではline_bufferから文字を削除するためには、test_readline.rbでやっているように、かなり周りくどい上にキーバインディングに依存する処理が必要になります。

パッチは((<PR#132|URL:https://github.com/ruby/ruby/pull/132>))です。

--- Readline.delete_text(start=0[, length]) -> self

startからlength文字を削除する。

lengthが省略された場合は末尾までを削除する。

startも省略された場合はすべてを削除する。

--- Readline.delete_text(start..end)        -> self

startからendまでの範囲内の文字を削除する。

=end

Associated revisions

Revision 56af74277c5a3fd9dc5f07524248f78a292b280e - 07/22/2013 12:37 AM - kouji (Kouji Takao)

ext/readline/readline.c (Init_readline): added

Readline.delete_text. [ruby-dev:45789] [Feature #6626]

ext/readline/extconf.rb: check for rl_delete_text() in Readline library.

Thanks, Nobuyoshi Nakada, for the patch.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42101 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 56af7427 - 07/22/2013 12:37 AM - kouji (Kouji Takao)

ext/readline/readline.c (Init_readline): added

Readline.delete_text. [ruby-dev:45789] [Feature #6626]

ext/readline/extconf.rb: check for rl_delete_text() in Readline library.

Thanks, Nobuyoshi Nakada, for the patch.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42101 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 182cf90d30f1319f094adcf4c37ea8921c348453 - 07/23/2013 06:00 PM - naruse (Yui NARUSE)

fix test of r42101 [Feature #6626]

rl_delete_text removes characters in line_buffer, but it doesn't move rl_point.

Therefore it may cause invalid rl_point.

On following case, test_input_metachar causes test_insert_text failure.

(test_input_metachar_multibyte) is skipped because of locale)

http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20130723T133302Z.log.html.gz

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42146 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 182cf90d - 07/23/2013 06:00 PM - naruse (Yui NARUSE)

fix test of r42101 [Feature #6626]

rl_delete_text removes characters in line_buffer, but it doesn't move rl_point.

Therefore it may cause invalid rl_point.

On following case, test_input_metachar causes test_insert_text failure.

(test_input_metachar_multibyte) is skipped because of locale)

http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20130723T133302Z.log.html.gz

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42146 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/01/2013 02:46 PM - shugo (Shugo Maeda)

- Tracker changed from Bug to Feature

#2 - 02/01/2013 02:47 PM - shugo (Shugo Maeda)

- Target version changed from 2.0.0 to 2.6

feature requestだと思うのでnext minorにしておきます。

#3 - 07/10/2013 06:33 AM - kouji (Kouji Takao)

大変遅くなりましたが、これを取り込もうと思って作業しています。

手元の環境(Mac OS X 10.7, GNU Readline 6.2)での動作確認は終わりました。

あと、Mac OSに標準添付されているEditLine(libedit)での動作を確認したらcommitしようかなと思っていたのですが、

このパッチには、string.cで定義されているrb_str_subpos関数を非公開から公開にする修正が含まれています。これを取り込んでもいいものなのか私では判断できませんでした。rb_str_subpos関数と同様の処理をext/re

adline/readline.cで実装すればrb_str_subpos関数を非公開のままにできると思って、rb_str_subpos関数を見てみましたが、なかなか長い処理なのですね...

すみませんが、どなたかrb_str_subpos関数を非公開から公開に変更してもよいかどうか判断していただけないでしょうか？

修正したい理由は、Readlineモジュールに対して本チケットで提案されている機能を実現するために、Readlineモジュールからrb_str_subpos関数を利用したいためです。利用できない場合は、rb_str_subpos関数と同

様の処理をReadlineモジュールにも実装することになり、コードの重複がうまれ、メンテナンス性が悪くなると考えています。

#4 - 07/22/2013 09:37 AM - kouji (Kouji Takao)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r42101.

Nobuyoshi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

ext/readline/readline.c (Init_readline): added

Readline.delete_text. [ruby-dev:45789] [Feature #6626]

ext/readline/extconf.rb: check for rl_delete_text() in Readline library.

Thanks, Nobuyoshi Nakada, for the patch.

Files

0001-string.c-rb_str_subpos.patch 1.09 KB 06/22/2012 nobu (Nobuyoshi Nakada)

0002-ext-readline-readline.c-Readline.delete_text.patch 4.32 KB 06/22/2012 nobu (Nobuyoshi Nakada)

0003-test-readline-test_readline.rb-use-delete_text.patch 1.2 KB 06/22/2012 nobu (Nobuyoshi Nakada)

Powered by TCPDF (www.tcpdf.org)

06/12/2025 2/2

http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20130723T133302Z.log.html.gz
bugs.ruby-lang.org/issues/6626
https://bugs.ruby-lang.org/issues/6626
http://www.tcpdf.org

